clear all
close all

% ------ This code ensures that the functions are in the DIPimage GUI ----
% ------ Needs only to be executed once                               ----
% ------ Can be put at the end of the startup.m file ----
% ------ Specify the directories where your functions and directories are (lines 8 and 20 in the code) 
myfunctiondir = pwd; %<-- change to where you put the m-files (usually pwd)
if ispc; sep=';'; else sep=':';end
dipaddpath(myfunctiondir)
tmp=dipgetpref('CommandFilePath');
dipsetpref('CommandFilePath',[ tmp sep myfunctiondir ])
dipsetpref('FileWriteWarning','off')

%dipimage
dipfig -unlink
close all
% ------------------------------------------------------------------------

myimagedir=[myfunctiondir(1:end-9) filesep 'images']; % <-- change to your image directory

tmp=dipgetpref('ImageFilePath');
dipsetpref('ImageFilePath',[ myimagedir sep tmp])


% ------ remout ------
out1 = remout('white',myimagedir,[0.05 0.1 0.25  0.5 0.75 1 2.5],1,10); 
out2 = remout('dark',myimagedir,[0.05 0.1 0.25 0.5 0.75 1 2.5 5 7.5 10],1,10);

% ------ lsq ------
[out3,out4] = lsq('dark',myimagedir,[ 0.05, 0.1 0.25 0.5 0.75 1 2.5 5 7.5 10],1,10,1);
[x,y] = lsq('white',myimagedir,[0.05 0.1 0.25 0.5 0.75 1 2.5 ],1,10,1);


% ------ background image estimated from different recorded exposure times ------
t = average('dark',myimagedir,3,1);
s = average('white',myimagedir,3,1);

% ------ averagesame, background image from recorded exposures ------
t = averagesame('dark',myimagedir, 0.05, 1,10);
s = averagesame('white',myimagedir, 2.5, 1,10);
s1= averagesame('dark',myimagedir, 2.5, 1,10);

% ------ av_gain ------
a = ef_gain(myimagedir,[0.1 0.5 0.75 1 2.5], 1, 10, 4);
b = ef_gain(myimagedir,[0.1 0.5 0.75 1 2.5], 1, 10, 1);

%------  r_square---------
rs=r_square('white', myimagedir, [ 0.05, 0.1 0.25 0.5 0.75 1 2.5],1,10,1);

%-----readout_noise_pix----
[out,rd]=readout_noise_pix(myimagedir,0.05,1,10);

% ------ corret raw images ------
im = readim([myimagedir filesep 'dezinger_Bin1_Exp02.50_white01.tif']);
[a b] = corr_raw(im, myimagedir, 2.5, 1,'nodarkcurrent');

im = readim([myimagedir filesep 'dezinger_Bin1_Exp02.50_white02.tif']);
[a2 b2] = corr_raw(im, myimagedir, 2.5, 1,'nodarkcurrent');

im = readim([myimagedir filesep 'dezinger_Bin1_Exp02.50_white03.tif']);
[a3 b3] = corr_raw(im, myimagedir, 3, 1,'darkcurrent');

% ------ mtf_noise ------
libdir=pwd;
an=cat(3, a,a2);
out=mtf_noise(an, libdir)

% ------ mtf_edge ------
st = readtimeseries([myimagedir filesep 'norm_corr_Bin1_Exp00.05_BeamStop*'],'tif',[1 10]);
f_bs = mtf_edge(st,1);


% ------ mtf_edgeAperture ------
st = readtimeseries([myimagedir filesep 'norm_corr_Bin1_Exp00.05_aperture*'],'tif',[1 10]);
f_ap = mtf_edge_Aperture(st);


% ------ DQE ------
b = load([myimagedir filesep 'MTF.mat'],'mtfux') ;
mtfwhole = b.mtfux;
dark = readim([myimagedir filesep 'av_dark_bin1_Exp02.50.tif']);
p = dqe(cat(3,an,a),dark,79,mtfwhole);













